////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Encode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Encode.cpp,v $
 * Revision 1.3  2000/08/24 15:39:24  syou
 * - multipart`̃[ƂsȏA؂ł
 * 肷̃oOCBBkCommon.cpp̉~XB
 *
 * Revision 1.2  2000/08/23 22:26:45  syou
 * - ̏I[s̃oOCBBkCommon.cppABkCommon.hőΏB
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#include "Pgpb2.h"


////////////////////////////////////////////////////////////////////////
// PGPÍ
BOOL CPgpb2::PGPOutgoing1(HWND hWnd, PGPContextRef context)
{
    // CBkMail IuWFNg\zB̎_ł͂܂A\[X̓[hĂȂB
    CBkMail mail(hWnd);

    // "To"A"Cc"A"Bcc"̊ewb_ mailaddress 𒊏oA|C^XgɊi[B
    char szTo[32768];
    char szCc[32768];
    char szBcc[32768];
    mail.GetHeader("To", szTo, 32768);
    mail.GetHeader("Cc", szCc, 32768);
    mail.GetHeader("Bcc", szBcc, 32768);

    CPointerList lstAddr;
    AddAddressList(lstAddr, szTo);
    AddAddressList(lstAddr, szCc);
    AddAddressList(lstAddr, szBcc);

    // i[ mailaddress Ƃ return B
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return FALSE;
    }

    // e mailaddress ɑΉL[܂Ƃ߂ĒoB
    PGPKeySetRef foundUserKeys = NULL;
    if (!GetKeySet(pItem, context, foundUserKeys)) {
        return FALSE;
    }

    // B2 ̊e Window Handle 擾AWindow 𖳌B
    // PGPsdk  Passphrase ̓_CAO\ƂɁAOvO Hook ă[U
    // ͂ Passphrase 𓐂݂ƂȂ悤A炩ߑ Hook ׂĔrSecurity Hook
    // ĂB
    // ̂߁A Window 쐬 Hook @\𗘗pĂ MFC vÓAPassphrase ̓_CA
    // O\ĂԁAK Window ̍쐬ɎsB
    // B2  MFC vOA Passphrase ̓_CAO\ĂԂ́A Window 
    // Ȃ悤ɂȂ΂ȂȂBAł͈ÍɗpL[I_CAO\
    // 킯ÂƂӖ͂ȂB
    HWND hMain, hTree, hList, hView;
    if (!m_pbka->GetWindowHandles(&hMain, &hTree, &hList, &hView)) {
        return FALSE;
    }
    EnableWindow(hMain, FALSE);

    // ÍɎgpL[I_CAO\B
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef encryptKeys = NULL;
    PGPUInt32 initialValue = m_bPGPMIME;
    PGPUInt32 resultValue;
    err = PGPRecipientDialog(
            context,
            foundUserKeys,
            TRUE,
            &encryptKeys,
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", "", initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );
    // CʂL
    EnableWindow(hMain, TRUE);

    if (IsPGPError(err)) {
        if(PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        if(PGPKeySetRefIsValid(encryptKeys)) {
            PGPFreeKeySet(encryptKeys);
        }
        return FALSE;
    }

    PGPUInt32 count;
    err = PGPCountKeys(encryptKeys, &count);
    if (IsPGPError(err) || count < 1) {
        return FALSE;
    }

    m_bPGPMIME = resultValue;
    LPSTR lpTxt = mail.GetPGPOriginalText(m_bPGPMIME);
    if (lpTxt == NULL) {
        return FALSE;
    }

    LPSTR lpArea = NULL;
    PGPSize size;
    PGPSize length = strlen(lpTxt);
    err = PGPEncode(
            context,
            PGPOEncryptToKeySet(context, encryptKeys),
            PGPOInputBuffer(context, lpTxt, length),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &size),
            PGPOArmorOutput(context, TRUE),
            PGPOLastOption(context)
            );

    free(lpTxt);
    if(PGPKeySetRefIsValid(foundUserKeys)) {
        PGPFreeKeySet(foundUserKeys);
    }
    if(PGPKeySetRefIsValid(encryptKeys)) {
        PGPFreeKeySet(encryptKeys);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        return FALSE;
    }

    if (m_bPGPMIME) {
        char szBoundary[1024];  // MIMEboundary ؂蕶
        char szData[8192];
        time_t t;
        time(&t);   // ݂̎擾 boundaryɖߍ
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"\r\n", szBoundary);
        mail.SetHeader("Content-Type", szData);
        mail.SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        mail.EmptyBody();

        CBkMailPartPtr apEncrypt1;
        apEncrypt1 = mail.SetChild(new CMIMEItem());
        apEncrypt1->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        apEncrypt1->SetHeader("Content-Type", "application/pgp-encrypted\r\n");
        apEncrypt1->AddBodyTail("Version: 1\r\n");

        CBkMailPartPtr apEncrypt2;
        apEncrypt2 = mail.AddChild(new CMIMEItem());
        apEncrypt2->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        apEncrypt2->SetHeader("Content-Type", "application/octet-stream\r\n");
        apEncrypt2->AddBodyTail(lpArea);
    }
    else {
        mail.EmptyBody();
        mail.AddBodyTail(lpArea);
    }

    mail.Commit();
    PGPFreeData(lpArea);
    m_pbka->Command(hWnd, "TextTop");

    return TRUE;
}


////////////////////////////////////////////////////////////////////////
// PGP
BOOL CPgpb2::PGPOutgoing2(HWND hWnd, PGPContextRef context)
{
    // CBkMail IuWFNg\zB -------------
    //
    // ̎_ł͂܂A\[X̓[hĂȂB
    CBkMail mail(hWnd);

    // "From"wb_ mailaddress 𒊏oA|C^XgɊi[B-------------
    char szFrom[32768];
    mail.GetHeader("From", szFrom, 32768);

    CPointerList lstAddr;
    AddAddressList(lstAddr, szFrom);

    // i[ mailaddress Ƃ return -------------
    CPointerItem* pItem = lstAddr.GetTop();
    if (pItem == NULL) {
        return FALSE;
    }

    // e mailaddress ɑΉL[܂Ƃ߂Ēo -------------
    PGPKeySetRef foundUserKeys = NULL;
    if (!GetKeySet(pItem, context, foundUserKeys)) {
        return FALSE;
    }

    // B2 ̊e Window Handle 擾AWindow 𖳌 -------------
    //
    // PGPsdk  Passphrase ̓_CAO\ƂɁAOvO Hook ă[U
    // ͂ Passphrase 𓐂݂ƂȂ悤A炩ߑ Hook ׂĔrSecurity Hook
    // ĂB
    // ̂߁A Window 쐬 Hook @\𗘗pĂ MFC vÓAPassphrase ̓_CA
    // O\ĂԁAK Window ̍쐬ɎsB
    // B2  MFC vOA Passphrase ̓_CAO\ĂԂ́A Window 
    // Ȃ悤ɂȂ΂ȂȂB
    HWND hMain, hTree, hList, hView;
    if (!m_pbka->GetWindowHandles(&hMain, &hTree, &hList, &hView)) {
        return FALSE;
    }
    EnableWindow(hMain, FALSE);

    // Passphrase ͂_CAO\B -------------
    PGPError err = kPGPError_NoErr;
    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    PGPUInt32 initialValue = m_bPGPMIME;
    PGPUInt32 resultValue;
    char *lpPassphrase = NULL;
    err = PGPSigningPassphraseDialog(
            context,
            foundUserKeys,
            &signingKey,
            PGPOUIOutputPassphrase(context, &lpPassphrase),
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIVerifyPassphrase(context, TRUE),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", NULL, initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );

    EnableWindow(hMain, TRUE);

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        return FALSE;
    }

    m_bPGPMIME = resultValue;
    LPSTR lpTxt = mail.GetPGPOriginalText(m_bPGPMIME);
    if (lpTxt == NULL) {
        return FALSE;
    }

    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;
    PGPOptionListRef encodeOptionList;
    err = PGPBuildOptionList(
            context,
            &encodeOptionList,
            PGPOInputBuffer(context, lpTxt, strlen(lpTxt)),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOSignWithKey(context, signingKey,
                PGPOPassphrase(context, lpPassphrase),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );
    if (IsPGPError(err)) {
        return FALSE;
    }

    if (m_bPGPMIME) {
        err = PGPAppendOptionList(
                encodeOptionList,
                PGPOArmorOutput(context, TRUE),
                PGPODetachedSig(context,
                    PGPOLastOption(context)),
                PGPOLastOption(context)
                );
    }
    else {
        err = PGPAppendOptionList(
                encodeOptionList,
                PGPOClearSign(context, TRUE),
                PGPOLastOption(context)
                );
    }

    if (IsPGPError(err)) {
        return FALSE;
    }

    err = PGPEncode(context, encodeOptionList, PGPOLastOption(context));

    PGPFreeData(lpPassphrase);
    if (PGPOptionListRefIsValid(encodeOptionList)) {
        PGPFreeOptionList(encodeOptionList);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        free(lpTxt);
        if (PGPKeySetRefIsValid(foundUserKeys)) {
            PGPFreeKeySet(foundUserKeys);
        }
        return FALSE;
    }

    if (m_bPGPMIME) {
        char szBoundary[1024];
        char szData[8192];
        char szHash[20];
        time_t t;

        if (!GetHashAlgorithm(signingKey, szHash)) {
            return FALSE;
        }

        time(&t);
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/signed;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-signature\"; micalg=pgp-%s\r\n",
            szBoundary, szHash);
        mail.SetHeader("Content-Type", szData);
        mail.SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        mail.EmptyBody();

        CBkMailPartPtr apContent;
        apContent = mail.SetChild(new CMIMEItem());
        apContent->FromString(lpTxt);

        CBkMailPartPtr apSign;
        apSign = mail.AddChild(new CMIMEItem());
        apSign->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        apSign->SetHeader("Content-Type", "application/pgp-signature\r\n");
        apSign->AddBodyTail(lpArea);
    }
    else {
        mail.EmptyBody();
        mail.AddBodyTail(lpArea);
    }

    mail.Commit();
    free(lpTxt);
    PGPFreeData(lpArea);
    if (PGPKeySetRefIsValid(foundUserKeys)) {
        PGPFreeKeySet(foundUserKeys);
    }
    m_pbka->Command(hWnd, "TextTop");

    return TRUE;
}


////////////////////////////////////////////////////////////////////////
// PGPÍ
BOOL CPgpb2::PGPOutgoing3(HWND hWnd, PGPContextRef context)
{
    CBkMail mail(hWnd);

    char szTo[32768];
    char szCc[32768];
    char szBcc[32768];
    char szFrom[32768];
    mail.GetHeader("To", szTo, 32768);
    mail.GetHeader("Cc", szCc, 32768);
    mail.GetHeader("Bcc", szBcc, 32768);
    mail.GetHeader("From", szFrom, 32768);

    CPointerList lstToAddr;
    CPointerList lstFromAddr;
    AddAddressList(lstToAddr, szTo);
    AddAddressList(lstToAddr, szCc);
    AddAddressList(lstToAddr, szBcc);
    AddAddressList(lstFromAddr, szFrom);

    CPointerItem* pToItem = lstToAddr.GetTop();
    CPointerItem* pFromItem = lstFromAddr.GetTop();
    if (pToItem == NULL || pFromItem == NULL) {
        return FALSE;
    }

    PGPKeySetRef foundToUserKeys = NULL;
    PGPKeySetRef foundFromUserKeys = NULL;
    if (!GetKeySet(pToItem, context, foundToUserKeys) ||  !GetKeySet(pFromItem, context, foundFromUserKeys)) {
        return FALSE;
    }

    PGPError err = kPGPError_NoErr;
    PGPKeySetRef encryptKeys = NULL;
    PGPUInt32 initialValue = m_bPGPMIME;
    PGPUInt32 resultValue;
    err = PGPRecipientDialog(
            context,
            foundToUserKeys,
            TRUE,
            &encryptKeys,
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIDialogOptions(context,
                PGPOUICheckbox(context, 1, "PGP/MIME_RFC2015", "", initialValue, &resultValue,
                    PGPOLastOption(context)),
                PGPOLastOption(context)),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundToUserKeys)) {
            PGPFreeKeySet(foundToUserKeys);
        }
        if (PGPKeySetRefIsValid(foundFromUserKeys)) {
            PGPFreeKeySet(foundFromUserKeys);
        }
        return FALSE;
    }

    HWND hMain, hTree, hList, hView;
    if (!m_pbka->GetWindowHandles(&hMain, &hTree, &hList, &hView)) {
        return FALSE;
    }

    EnableWindow(hMain, FALSE);

    PGPKeyRef signingKey = kInvalidPGPKeyRef;
    LPSTR lpPassphrase = NULL;
    err = PGPSigningPassphraseDialog(
            context,
            foundFromUserKeys,
            &signingKey,
            PGPOUIOutputPassphrase(context, &lpPassphrase),
            PGPOUIParentWindowHandle(context, hWnd),
            PGPOUIVerifyPassphrase(context, TRUE),
            PGPOLastOption(context)
            );

    EnableWindow(hMain, TRUE);

    if (IsPGPError(err)) {
        if (PGPKeySetRefIsValid(foundToUserKeys)) {
            PGPFreeKeySet(foundToUserKeys);
        }
        if (PGPKeySetRefIsValid(foundFromUserKeys)) {
            PGPFreeKeySet(foundFromUserKeys);
        }
        return FALSE;
    }

    m_bPGPMIME = resultValue;
    LPSTR lpTxt = mail.GetPGPOriginalText(m_bPGPMIME);
    if (lpTxt == NULL) {
        return FALSE;
    }

    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;
    PGPSize inputSize = strlen(lpTxt);
    err = PGPEncode(
            context,
            PGPOInputBuffer(context, lpTxt, inputSize),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOEncryptToKeySet(context, encryptKeys),
            PGPOSignWithKey(context, signingKey,
                PGPOPassphrase(context, lpPassphrase),
                PGPOLastOption(context)),
            PGPOArmorOutput(context, TRUE),
            PGPOLastOption(context)
            );

    free(lpTxt); //m_pbka->Free(lpTxt);
    if (PGPKeySetRefIsValid(foundToUserKeys)) {
        PGPFreeKeySet(foundToUserKeys);
    }
    if (PGPKeySetRefIsValid(foundFromUserKeys)) {
        PGPFreeKeySet(foundFromUserKeys);
    }
    if(PGPKeySetRefIsValid(encryptKeys)) {
        PGPFreeKeySet(encryptKeys);
    }
    if (IsPGPError(err) || lpArea == NULL) {
        return FALSE;
    }

    if (m_bPGPMIME) {
        char szBoundary[1024];  // MIMEboundary ؂蕶
        char szData[8192];
        time_t t;
        time(&t);   // ݂̎擾 boundaryɖߍ
        sprintf(szBoundary, "===[PGP/MIME_RFC2015]===%08X.%04X===", (DWORD)t, &t);
        sprintf(szData, "multipart/encrypted;\r\n boundary=\"%s\";\r\n protocol=\"application/pgp-encrypted\"\r\n", szBoundary);
        mail.SetHeader("Content-Type", szData);
        mail.SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        mail.EmptyBody();

        CBkMailPartPtr apEncrypt1;
        apEncrypt1 = mail.SetChild(new CMIMEItem());
        apEncrypt1->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        apEncrypt1->SetHeader("Content-Type", "application/pgp-encrypted\r\n");
        apEncrypt1->AddBodyTail("Version: 1\r\n");

        CBkMailPartPtr apEncrypt2;
        apEncrypt2 = mail.AddChild(new CMIMEItem());
        apEncrypt2->SetHeader("Content-Transfer-Encoding", "7bit\r\n");
        apEncrypt2->SetHeader("Content-Type", "application/octet-stream\r\n");
        apEncrypt2->AddBodyTail(lpArea);
    }
    else {
        mail.EmptyBody();
        mail.AddBodyTail(lpArea);
    }

    mail.Commit();
    PGPFreeData(lpArea);
    m_pbka->Command(hWnd, "TextTop");

    return TRUE;
}

